(function() {
  var Element, Vipe, ensure_array, events, fs, libs, pass, sys, xml2js, _;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  };
  _ = (require('underscore'))._;
  sys = require('sys');
  fs = require('fs');
  xml2js = require('xml2js');
  events = require('events');
  pass = null;
  ensure_array = function(array) {
    if (_.isUndefined(array)) {
      return [];
    } else {
      if (_.isArray(array)) {
        return array;
      } else {
        return [array];
      }
    }
  };
  Element = (function() {
    function Element(data) {
      this.attributes = {};
      this.content = '';
      if (data['@']) {
        this.attributes = data['@'];
      }
      _(this.attributes).each(__bind(function(value, key) {
        return this[key] = value;
      }, this));
      if (_.isString(data)) {
        this.content = data;
      } else {
        this.content = data['#'];
      }
    }
    Element.prototype.c = function() {
      return this.content;
    };
    Element.prototype.a = function(attr) {
      if (attr) {
        return this.attributes[attr];
      } else {
        return this.attributes;
      }
    };
    return Element;
  })();
  Vipe = {
    debug: true,
    Parser: (function() {
      function _Class(raw_xml, callback) {
        var parser;
        this.nodes = {};
        this.libs = {};
        this.starts = [];
        this.next_thread = 1;
        this.threads = [];
        parser = new xml2js.Parser;
        parser.addListener('end', __bind(function(result) {
          if (result.head) {
            _(ensure_array(result.head.lib)).each(__bind(function(lib) {
              return this.lib((new Element(lib)).content);
            }, this));
          }
          this.nodes = _(ensure_array(result.nodes.node)).each(__bind(function(node) {
            return this.node(node);
          }, this));
          this.starts = ensure_array(result.head.start);
          return callback(this);
        }, this));
        parser.parseString(raw_xml);
      }
      _Class.prototype.run = function() {
        var start, _i, _len, _ref, _results;
        _ref = this.starts;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          start = _ref[_i];
          this.nodes[start].start(this.next_thread);
          this.threads << this.next_thread++;
          console.log(this.threads);
          _results.push(console.log(this.next_thread));
        }
        return _results;
      };
      _Class.prototype.node = function(node_data) {
        var e;
        try {
          return this.nodes[node_data['@']['id']] = new this.libs[node_data['@']['type']](node_data['@']['id'], node_data['@']['type'], (function() {
            var _i, _len, _ref, _results;
            _ref = ensure_array(node_data['input']);
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              e = _ref[_i];
              _results.push(new Element(e));
            }
            return _results;
          })(), (function() {
            var _i, _len, _ref, _results;
            _ref = ensure_array(node_data['output']);
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              e = _ref[_i];
              _results.push(new Element(e));
            }
            return _results;
          })(), (function() {
            var _i, _len, _ref, _results;
            _ref = ensure_array(node_data['reference']);
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              e = _ref[_i];
              _results.push(new Element(e));
            }
            return _results;
          })(), (function() {
            var _i, _len, _ref, _results;
            _ref = ensure_array(node_data['value']);
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              e = _ref[_i];
              _results.push(new Element(e));
            }
            return _results;
          })(), this);
        } catch (e) {
          if (e.type === 'called_non_callable') {
            return console.log("Could not find library type '" + node_data['@']['type'] + "'");
          } else {
            throw e;
          }
        }
      };
      _Class.prototype.lib = function(name) {
        if (libs[name].nodes) {
          return _(libs[name].nodes).each(__bind(function(val, key) {
            return this.libs[name + '.' + key] = val;
          }, this));
        }
      };
      return _Class;
    })(),
    Node: (function() {
      function _Class(id, type, inputs, outputs, references, values, parent) {
        var i;
        this.id = id;
        this.type = type;
        this.parent = parent;
        this.inputs = {};
        this.outputs = {};
        this.references = {};
        this.values = {};
        this.threads = {};
        _(inputs).each(__bind(function(input) {
          return this.inputs[input.name] = new Vipe.NodeInput(input.name, this, input.content);
        }, this));
        _(outputs).each(__bind(function(output) {
          return this.outputs[output.name] = new Vipe.NodeOutput(output.name, this, output.content);
        }, this));
        _(references).each(__bind(function(reference) {
          return this.references[reference.name] = new Vipe.NodeReference(reference.name, this, reference.content);
        }, this));
        i = 0;
        _(values).each(__bind(function(value) {
          if (value.key) {
            return this.values[value.key] = value.content;
          } else {
            this.values[i] = value.content;
            return i++;
          }
        }, this));
      }
      __extends(_Class, events.EventEmitter);
      _Class.prototype.ensure_thread = function(thread) {
        if (!this.threads[thread]) {
          return this.threads[thread] = {
            inputs: {},
            outputs: {},
            references: {}
          };
        }
      };
      _Class.prototype.inputs_filled = function(thread) {
        return _.size(this.threads[thread].inputs) === this.inputs.length;
      };
      _Class.prototype.references_filled = function(thread) {
        return _.size(this.threads[thread].references) === this.references.length;
      };
      _Class.prototype.ping_inputs = function(thread) {
        this.ensure_thread(thread);
        return _(this.inputs).each(__bind(function(input) {
          return input.ping(thread);
        }, this));
      };
      _Class.prototype.input = function(name, source, object, thread) {
        this.ensure_thread(thread);
        this.threads[thread].inputs[name] = object;
        if (this.inputs_filled(thread)) {
          this.emit('inputs', thread, this.threads[thread].inputs);
        }
        return this.ping_inputs(thread);
      };
      _Class.prototype.reference = function(name, source, object, thread) {
        this.ensure_thread(thread);
        this.threads[thread].references[name] = object;
        if (this.inputs_filled(thread)) {
          this.emit('reference', thread, object);
        }
        if (this.references_filled(thread)) {
          return this.emit('references', thread, this.threads[thread].references);
        }
      };
      _Class.prototype.ping = function(name, dest, thread) {
        if (Vipe.debug) {
          return console.log("Ping to " + name + " from " + dest + " on thread " + thread);
        }
      };
      _Class.prototype.start = function() {};
      return _Class;
    })(),
    NodeInput: (function() {
      function _Class(name, node, source) {
        var parts;
        this.name = name;
        this.node = node;
        parts = source.split('/');
        this.source = parts[0];
        if (parts[1]) {
          this.type = parts[1];
        } else {
          this.type = false;
        }
      }
      _Class.prototype.ping = function(thread) {
        return this.node.parent.nodes[this.source].ping(this.name, this.node.id, thread);
      };
      return _Class;
    })(),
    NodeOutput: (function() {
      function _Class(name, node, source) {
        var parts;
        this.name = name;
        this.node = node;
        parts = source.split('/');
        this.dest = parts[0];
        if (parts[1]) {
          this.type = parts[1];
        } else {
          this.type = false;
        }
      }
      return _Class;
    })(),
    NodeReference: (function() {
      function _Class(name, node, source) {
        var parts;
        this.name = name;
        this.node = node;
        parts = source.split('/');
        this.source = parts[0];
        if (parts[1]) {
          this.type = parts[1];
        } else {
          this.type = false;
        }
      }
      return _Class;
    })()
  };
  libs = {
    core: {
      types: {
        string: (function() {
          function _Class(value) {
            this.value = value;
            this.type = 'core/string';
          }
          return _Class;
        })(),
        hash: (function() {
          function _Class(value) {
            this.value = value;
            this.type = 'core/hash';
          }
          return _Class;
        })()
      },
      nodes: {
        string: (function() {
          function _Class() {
            _Class.__super__.constructor.apply(this, arguments);
          }
          __extends(_Class, Vipe.Node);
          pass;
          return _Class;
        })(),
        hash: (function() {
          function _Class() {
            _Class.__super__.constructor.apply(this, arguments);
          }
          __extends(_Class, Vipe.Node);
          pass;
          return _Class;
        })()
      }
    },
    http: {
      types: {
        response: (function() {
          function _Class(server, request, response) {
            this.server = server;
            this.request = request;
            this.response = response;
            this.type = 'http/response';
          }
          return _Class;
        })()
      },
      nodes: {
        'server': (function() {
          function _Class() {
            _Class.__super__.constructor.apply(this, arguments);
          }
          __extends(_Class, Vipe.Node);
          _Class.prototype.test = function() {
            console.log('test');
            return console.log(this.id);
          };
          return _Class;
        })(),
        'res.writeHead': (function() {
          function _Class() {
            _Class.__super__.constructor.apply(this, arguments);
          }
          __extends(_Class, Vipe.Node);
          pass;
          return _Class;
        })(),
        'res.write': (function() {
          function _Class() {
            _Class.__super__.constructor.apply(this, arguments);
          }
          __extends(_Class, Vipe.Node);
          pass;
          return _Class;
        })(),
        'close': (function() {
          function _Class() {
            _Class.__super__.constructor.apply(this, arguments);
          }
          __extends(_Class, Vipe.Node);
          pass;
          return _Class;
        })()
      }
    }
  };
  new Vipe.Parser(fs.readFileSync('../example.xml'), function(vipe) {});
}).call(this);
